VSphereCluster [infrastructure.cluster.x-k8s.io/v1beta1]

Description
VSphereCluster is the Schema for the vsphereclusters API.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

VSphereClusterSpec defines the desired state of VSphereCluster.

statusobject

VSphereClusterStatus defines the observed state of VSphereClusterSpec.

.spec

Description
VSphereClusterSpec defines the desired state of VSphereCluster.
Type
object
PropertyTypeDescription
clusterModulesarray

ClusterModules hosts information regarding the anti-affinity vSphere constructs for each of the objects responsible for creation of VM objects belonging to the cluster.

controlPlaneEndpointobject

ControlPlaneEndpoint represents the endpoint used to communicate with the control plane.

disableClusterModuleboolean

DisableClusterModule is used to explicitly turn off the ClusterModule feature. This should work along side NodeAntiAffinity feature flag. If the NodeAntiAffinity feature flag is turned off, this will be disregarded.

failureDomainSelectorobject

FailureDomainSelector is the label selector to use for failure domain selection for the control plane nodes of the cluster. If not set (nil), selecting failure domains will be disabled. An empty value ({}) selects all existing failure domains. A valid selector will select all failure domains which match the selector.

identityRefobject

IdentityRef is a reference to either a Secret or VSphereClusterIdentity that contains the identity to use when reconciling the cluster.

serverstring

Server is the address of the vSphere endpoint.

thumbprintstring

Thumbprint is the colon-separated SHA-1 checksum of the given vCenter server's host certificate

.spec.clusterModules

Description
ClusterModules hosts information regarding the anti-affinity vSphere constructs for each of the objects responsible for creation of VM objects belonging to the cluster.
Type
array

.spec.clusterModules[]

Description
ClusterModule holds the anti affinity construct `ClusterModule` identifier in use by the VMs owned by the object referred by the TargetObjectName field.
Type
object
Required
controlPlanemoduleUUIDtargetObjectName
PropertyTypeDescription
controlPlaneboolean

ControlPlane indicates whether the referred object is responsible for control plane nodes. Currently, only the KubeadmControlPlane objects have this flag set to true. Only a single object in the slice can have this value set to true.

moduleUUIDstring

ModuleUUID is the unique identifier of the ClusterModule used by the object.

targetObjectNamestring

TargetObjectName points to the object that uses the Cluster Module information to enforce anti-affinity amongst its descendant VM objects.

.spec.controlPlaneEndpoint

Description
ControlPlaneEndpoint represents the endpoint used to communicate with the control plane.
Type
object
Required
hostport
PropertyTypeDescription
hoststring

The hostname on which the API server is serving.

portinteger

The port on which the API server is serving.

.spec.failureDomainSelector

Description
FailureDomainSelector is the label selector to use for failure domain selection for the control plane nodes of the cluster. If not set (`nil`), selecting failure domains will be disabled. An empty value (`{}`) selects all existing failure domains. A valid selector will select all failure domains which match the selector.
Type
object
PropertyTypeDescription
matchExpressionsarray

matchExpressions is a list of label selector requirements. The requirements are ANDed.

matchLabelsobject

matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

.spec.failureDomainSelector.matchExpressions

Description
matchExpressions is a list of label selector requirements. The requirements are ANDed.
Type
array

.spec.failureDomainSelector.matchExpressions[]

Description
A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
Type
object
Required
keyoperator
PropertyTypeDescription
keystring

key is the label key that the selector applies to.

operatorstring

operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

valuesarray

values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

.spec.failureDomainSelector.matchExpressions[].values

Description
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
Type
array

.spec.failureDomainSelector.matchExpressions[].values[]

Type
string

.spec.failureDomainSelector.matchLabels

Description
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
Type
object

.spec.identityRef

Description
IdentityRef is a reference to either a Secret or VSphereClusterIdentity that contains the identity to use when reconciling the cluster.
Type
object
Required
kindname
PropertyTypeDescription
kindstring

Kind of the identity. Can either be VSphereClusterIdentity or Secret

namestring

Name of the identity.

.status

Description
VSphereClusterStatus defines the observed state of VSphereClusterSpec.
Type
object
PropertyTypeDescription
conditionsarray

Conditions defines current service state of the VSphereCluster.

failureDomainsobject

FailureDomains is a list of failure domain objects synced from the infrastructure provider.

readyboolean
v1beta2object

v1beta2 groups all the fields that will be added or modified in VSphereCluster's status with the V1Beta2 version.

vCenterVersionstring

VCenterVersion defines the version of the vCenter server defined in the spec.

.status.conditions

Description
Conditions defines current service state of the VSphereCluster.
Type
array

.status.conditions[]

Description
Condition defines an observation of a Cluster API resource operational state.
Type
object
Required
lastTransitionTimestatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This field may be empty.

reasonstring

reason is the reason for the condition's last transition in CamelCase. The specific API may choose whether or not this field is considered a guaranteed API. This field may be empty.

severitystring

severity provides an explicit classification of Reason code, so the users or machines can immediately understand the current situation and act accordingly. The Severity field MUST be set only when Status=False.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase. Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important.

.status.failureDomains

Description
FailureDomains is a list of failure domain objects synced from the infrastructure provider.
Type
object

.status.v1beta2

Description
v1beta2 groups all the fields that will be added or modified in VSphereCluster's status with the V1Beta2 version.
Type
object
PropertyTypeDescription
conditionsarray

conditions represents the observations of a VSphereCluster's current state. Known condition types are Ready, FailureDomainsReady, VCenterAvailable, ClusterModulesReady and Paused.

.status.v1beta2.conditions

Description
conditions represents the observations of a VSphereCluster's current state. Known condition types are Ready, FailureDomainsReady, VCenterAvailable, ClusterModulesReady and Paused.
Type
array

.status.v1beta2.conditions[]

Description
Condition contains details for one aspect of the current state of this API Resource.
Type
object
Required
lastTransitionTimemessagereasonstatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This may be an empty string.

observedGenerationinteger

observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

reasonstring

reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase.

API Endpoints

The following API endpoints are available:

  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters
    • DELETE: delete collection of VSphereCluster
    • GET: list objects of kind VSphereCluster
    • POST: create a new VSphereCluster
  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters/{name}
    • DELETE: delete the specified VSphereCluster
    • GET: read the specified VSphereCluster
    • PATCH: partially update the specified VSphereCluster
    • PUT: replace the specified VSphereCluster
  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters/{name}/status
    • GET: read status of the specified VSphereCluster
    • PATCH: partially update status of the specified VSphereCluster
    • PUT: replace status of the specified VSphereCluster

/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters

HTTP method
DELETE
Description
delete collection of VSphereCluster
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind VSphereCluster
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereCluster schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
201 - CreatedVSphereCluster schema
202 - AcceptedVSphereCluster schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters/{name}

HTTP method
DELETE
Description
delete the specified VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified VSphereCluster
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereCluster schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
201 - CreatedVSphereCluster schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclusters/{name}/status

HTTP method
GET
Description
read status of the specified VSphereCluster
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified VSphereCluster
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereCluster schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereCluster schema
201 - CreatedVSphereCluster schema
401 - UnauthorizedEmpty